// Header file for CGenCodeData class
//
// American LaserWare, Inc
// Pat Summers
//
///////////////////////////////////////////////////////////

//// 1.0553 PAT 06.06.01 CUSTOM BARCODE ////
// Added this file
//// 1.0553 ////////////////////////////////

// GenCode.h

#ifndef CGENCODEDATA
#define CGENCODEDATA

// Include standard headers
#ifndef _DLL
	#include <afx.h>
	#include <afxwin.h>
#endif

// Version info
#define GENCODEDATA_2001_06_06			0
#define VER_GENCODEDATA					GENCODEDATA_2001_06_06

//// 1.0621 PAT 29.10.01 GENCODE INTERFACE CHANGE ////
#define BC_GENCODE_VER_INFILE_0		0
#define BC_GENCODE_VER_OUTFILE_0	0
//// 1.0621 //////////////////////////////////////////

// CGenCode specific constant definitions
#define BC_GENCODE_NAME						_T("User Defined")
#define BC_GENCODE_NAME_DEFAULT				_T("<NO NAME>")
#define BC_GENCODE_EXE_DEFAULT				_T("GenCode.exe")
#define BC_GENCODE_INPUT_DEFAULT			_T("GenCodeIn.txt")
#define BC_GENCODE_OUTPUT_DEFAULT			_T("GenCodeOut.txt")
#define BC_GENCODE_ARGS_MAX					5


class CGenCodeData : public CObject
{
	DECLARE_SERIAL (CGenCodeData)

//Attributes
public:
	int
		m_nVersion;

	//// 1.0621 PAT 29.10.01 GENCODE INTERFACE CHANGE ////
	int
		m_nInputFileVersion,
		m_nOutputFileVersion;
	//// 1.0621 //////////////////////////////////////////

	CString
		m_sName,
		m_sExe,
		m_sInput,
		m_sOutput,
		m_asArgValues[BC_GENCODE_ARGS_MAX],
		m_asArgNames[BC_GENCODE_ARGS_MAX];
	BOOL
		m_abArgFlags[BC_GENCODE_ARGS_MAX];
	
// Implementations
public:
	CGenCodeData();						// Constructor
	~CGenCodeData();					// Destructor
	void Init(void);					// Initializes members
	void Serialize(CArchive&);			// Load / Save routines

//Operators
public:
	// Equate =
	void operator =( const CGenCodeData& src );
	// Equivalence ==
	BOOL operator ==( const CGenCodeData& src );
};

#endif  // GENCODEDATA

