// LM50Time.h

// Header file for the CLM50Time class.
//
// Pat Summers
// American Laserware, Inc.

#ifndef	LM50TIME
#define LM50TIME


// Define the class
class CLM50Time
{
public:
	// Constructor
	CLM50Time(void);
	// Destructor
	~CLM50Time(void);

	// Initalization for class
private:
	static BOOL
		m_bInitialized;
public:
	static void Init(void);
	
	// Delays
	// Millisecond
	static unsigned long Delay(unsigned long nDelay);
	static unsigned long DelayMicro(unsigned long nDelay);

	// High Performance Counter
protected:
	static BOOL
		m_bHPCAvailable;
	static ULONGLONG
		m_n64HPCResolution,
		m_n64HPCCounter;
public:
	static ULONGLONG LItoULL(LARGE_INTEGER l64);
	static BOOL QueryPerformanceFrequency(ULONGLONG *lpFreq);
	static BOOL QueryPerformanceCounter(ULONGLONG *lpCount);
	
	static void InitHPC(void);
	static BOOL HPCIsAvailable(void);
	static unsigned long HPCGetResolution(void);
	static unsigned long HPCGetElapsed(void);

	//// REV L003 - 20020409 - SIMMER CURRENT ////
	static BOOL HPCGetCurrentCount(__int64* pCount);
	static BOOL HPCGetCurrentSecond(long double *pSecond);
	//// REV L003 ////////////////////////////////

};

#endif	// LM50TIME


