// Header file for the CRTC2Data class
//
// RTC2Data.h

// This class is the data structure for holding data concerning the
// configuration of the RTC2 board

//// 1.0263 PAT 22.12.99 RTC2 DRIVER DLG ////
// Created file
//// 1.0263 /////////////////////////////////

#ifndef CRTC2DATA
#define CRTC2DATA

#include <afx.h>

#define RTC2DATA_1999_12_23			0
//// 1.0269 PAT 29.12.99 TEMP CONFIG FOR CONFIG PAGES ////
// Adds m_bVariableAngleDelay
#define RTC2DATA_1999_12_29			100
//// 1.0269 //////////////////////////////////////////////
//// 1.0375 PAT 01.06.00 RTC2 FLY ADD-ON ////
// Adds On-The-Fly variables
#define RTC2DATA_2000_06_01			200
//// 1.0375 /////////////////////////////////

//// 1.0433 PAT 12.09.00 RTC2 3D UPDATE ////
#define RTC2DATA_2000_09_12			300
//// 1.0433 ////////////////////////////////

//// 1.0475 PAT 22.11.00 RTC2 FLY Y AXIS ////
// Add Y axis On-Th-Fly variables
#define RTC2DATA_2000_11_22			400
//// 1.0475 /////////////////////////////////

//// 1.0533 PAT 02.05.01 RTC I/O PATCH ////
// Add IO source/dest flags
#define RTC2DATA_2001_05_02			500
//// 1.0533 ///////////////////////////////

#define VER_RTC2DATA				RTC2DATA_2001_05_02


#ifdef _ALIUSE
	#include ".\RTC2Constants.h"
#else
	#include "RTC2Constants.h"
#endif

//// 1.0391 PAT 05.07.00 MORE RTC2 FLY ////
// Changed m_dFlyPPI_X to m_dFlyCPI_X
//// 1.0391 ///////////////////////////////


class CRTC2Data : public CObject
{

	DECLARE_SERIAL( CRTC2Data )

// Attributes
public:
	// Version info
	UINT
		m_nVersion;

	UINT
		m_nBaseAddress;
	CString
		m_sDLLFileName,
		m_sProgFileName,
		m_sCTBFileName;
	UINT
		m_nLaserType;
	BOOL
		//// 1.0281 PAT 03.02.00 RTC2 DETAILS DLG FIX ////
		// Replaced this variable
		//m_bLeeLaser;
		m_bDUMMY;
		//// 1.0281 //////////////////////////////////////

	UINT
		m_nArcRes;

	//// 1.0269 PAT 29.12.99 TEMP CONFIG FOR CONFIG PAGES ////
	BOOL
		m_bVariableAngleDelay;
	//// 1.0269 //////////////////////////////////////////////

	//// 1.0375 PAT 01.06.00 RTC2 FLY ADD-ON ////
	//// 1.0475 PAT 22.11.00 RTC2 FLY Y AXIS ////
	//	BOOL
	//		m_bFlyEnable;
	//	double
	//		m_dFlyCPI_X;
	BOOL
		m_bFlyEnableX;
	double
		m_dFlyCPI_X;
	BOOL
		m_bFlyEnableY;
	double
		m_dFlyCPI_Y;
	//// 1.0475 /////////////////////////////////
	//// 1.0375 /////////////////////////////////

	//// 1.0433 PAT 12.09.00 RTC2 3D UPDATE ////
	BOOL
		m_bVarioZCal;
	double
		m_dVarioZCalA,
		m_dVarioZCalB,
		m_dVarioZCalC;
	//// 1.0433 ////////////////////////////////

	//// 1.0533 PAT 02.05.01 RTC I/O PATCH ////
	BOOL
		m_bEnableExtStartStop,
		m_bEnableIOExtension;
	//// 1.0533 ///////////////////////////////

// Implementations
public:
	CRTC2Data(void);
	~CRTC2Data(void);

	void Init(void);

    void Serialize( CArchive& ar );


// Operators
	void operator =( const CRTC2Data& src );
	BOOL operator ==( const CRTC2Data& src );
public:
};

#endif // CRTC2DATA

