// RTC3DLL_TYPE.h
//
// This file contains the type declarations
// for the functions in the RTC3 DLL that
// are made accessible to ProLase

#ifndef RTC3DLL_TYPE
#define RTC3DLL_TYPE

typedef short (__stdcall *N_LOAD_VARPOLYDELAY)(unsigned short n, char* stbfilename, unsigned short tableno);
typedef short (__stdcall *LOAD_VARPOLYDELAY)(char* stbfilename, unsigned short tableno);
typedef short (__stdcall *N_LOAD_PROGRAM_FILE)(unsigned short n, char* name);
typedef short (__stdcall *LOAD_PROGRAM_FILE)(char* name);
typedef short (__stdcall *N_LOAD_CORRECTION_FILE)(unsigned short n, char* filename, short cortable, double kx, double ky, double phi, double xoffset, double yoffset);
typedef short (__stdcall *LOAD_CORRECTION_FILE)(char* filename, short cortable, double kx, double ky, double phi, double xoffset, double yoffset);
typedef short (__stdcall *N_LOAD_Z_TABLE)(unsigned short n, double a, double b, double c);
typedef short (__stdcall *LOAD_Z_TABLE)(double a, double b, double c);
typedef void (__stdcall *N_LIST_NOP)(unsigned short n);
typedef void (__stdcall *LIST_NOP)(void);
typedef void (__stdcall *N_SET_END_OF_LIST)(unsigned short n);
typedef void (__stdcall *SET_END_OF_LIST)(void);
typedef void (__stdcall *N_JUMP_ABS_3D)(unsigned short n, short x, short y, short z);
typedef void (__stdcall *JUMP_ABS_3D)(short x, short y, short z);
typedef void (__stdcall *N_JUMP_ABS)(unsigned short n, short x, short y);
typedef void (__stdcall *JUMP_ABS)(short x, short y);
typedef void (__stdcall *N_MARK_ABS_3D)(unsigned short n, short x, short y, short z);
typedef void (__stdcall *MARK_ABS_3D)(short x, short y, short z);
typedef void (__stdcall *N_MARK_ABS)(unsigned short n, short x, short y);
typedef void (__stdcall *MARK_ABS)(short x, short y);
typedef void (__stdcall *N_JUMP_REL_3D)(unsigned short n, short dx, short dy, short dz);
typedef void (__stdcall *JUMP_REL_3D)(short dx, short dy, short dz);
typedef void (__stdcall *N_JUMP_REL)(unsigned short n, short dx, short dy);
typedef void (__stdcall *JUMP_REL)(short dx, short dy);
typedef void (__stdcall *N_MARK_REL_3D)(unsigned short n, short dx, short dy, short dz);
typedef void (__stdcall *MARK_REL_3D)(short dx, short dy, short dz);
typedef void (__stdcall *N_MARK_REL)(unsigned short n, short dx, short dy);
typedef void (__stdcall *MARK_REL)(short dx, short dy);
typedef void (__stdcall *N_WRITE_8BIT_PORT_LIST)(unsigned short n, unsigned short value);
typedef void (__stdcall *WRITE_8BIT_PORT_LIST)(unsigned short value);
typedef void (__stdcall *N_WRITE_DA_1_LIST)(unsigned short n, unsigned short value);
typedef void (__stdcall *WRITE_DA_1_LIST)(unsigned short value);
typedef void (__stdcall *N_WRITE_DA_2_LIST)(unsigned short n, unsigned short value);
typedef void (__stdcall *WRITE_DA_2_LIST)(unsigned short value);
typedef void (__stdcall *N_SET_OFFSET_LIST)(unsigned short n, short xoffset, short yoffset);
typedef void (__stdcall *SET_OFFSET_LIST)(short xoffset, short yoffset);
typedef void (__stdcall *N_LONG_DELAY)(unsigned short n, unsigned short value);
typedef void (__stdcall *LONG_DELAY)(unsigned short value);
typedef void (__stdcall *N_LASER_ON_LIST)(unsigned short n, unsigned short value);
typedef void (__stdcall *LASER_ON_LIST)(unsigned short value);
typedef void (__stdcall *N_SET_JUMP_SPEED)(unsigned short n, double speed);
typedef void (__stdcall *SET_JUMP_SPEED)(double speed);
typedef void (__stdcall *N_SET_MARK_SPEED)(unsigned short n, double speed);
typedef void (__stdcall *SET_MARK_SPEED)(double speed);
typedef void (__stdcall *N_SET_LASER_DELAYS)(unsigned short n, short ondelay, short offdelay);
typedef void (__stdcall *SET_LASER_DELAYS)(short ondelay, short offdelay);
typedef void (__stdcall *N_SET_SCANNER_DELAYS)(unsigned short n, unsigned short jumpdelay, unsigned short markdelay, unsigned short polydelay);
typedef void (__stdcall *SET_SCANNER_DELAYS)(unsigned short jumpdelay, unsigned short markdelay, unsigned short polydelay);
typedef void (__stdcall *N_SET_LIST_JUMP)(unsigned short n, unsigned short position);
typedef void (__stdcall *SET_LIST_JUMP)(unsigned short position);
typedef void (__stdcall *N_SET_INPUT_POINTER)(unsigned short n, unsigned short pointer);
typedef void (__stdcall *SET_INPUT_POINTER)(unsigned short pointer);
typedef void (__stdcall *SET_LIST_POINTER)(unsigned short list, unsigned short pointer);
typedef void (__stdcall *N_LIST_CALL)(unsigned short n, unsigned short position);
typedef void (__stdcall *LIST_CALL)(unsigned short position);
typedef void (__stdcall *N_LIST_RETURN)(unsigned short n);
typedef void (__stdcall *LIST_RETURN)(void);
typedef void (__stdcall *N_Z_OUT_LIST)(unsigned short n, short z);
typedef void (__stdcall *Z_OUT_LIST)(short z);
typedef void (__stdcall *N_SET_STANDBY_LIST)(unsigned short n, unsigned short half_period, unsigned short pulse);
typedef void (__stdcall *SET_STANDBY_LIST)(unsigned short half_period, unsigned short pulse);
typedef void (__stdcall *N_TIMED_JUMP_ABS)(unsigned short n, short x, short y, double time);
typedef void (__stdcall *TIMED_JUMP_ABS)(short x, short y, double time);
typedef void (__stdcall *N_TIMED_MARK_ABS)(unsigned short n, short x, short y, double time);
typedef void (__stdcall *TIMED_MARK_ABS)(short x, short y, double time);
typedef void (__stdcall *N_TIMED_JUMP_REL)(unsigned short n, short dx, short dy, double time);
typedef void (__stdcall *TIMED_JUMP_REL)(short dx, short dy, double time);
typedef void (__stdcall *N_TIMED_MARK_REL)(unsigned short n, short dx, short dy, double time);
typedef void (__stdcall *TIMED_MARK_REL)(short dx, short dy, double time);
typedef void (__stdcall *N_SET_LASER_TIMING)(unsigned short n, unsigned short halfperiod, unsigned short pulse1, unsigned short pulse2, unsigned short timebase);
typedef void (__stdcall *SET_LASER_TIMING)(unsigned short halfperiod, unsigned short pulse1, unsigned short pulse2, unsigned short timebase);
typedef void (__stdcall *N_SET_WOBBEL)(unsigned short n, unsigned short amplitude, double frequency);
typedef void (__stdcall *SET_WOBBEL)(unsigned short amplitude, double frequency);
typedef void (__stdcall *N_SET_FLY_X)(unsigned short n, double kx);
typedef void (__stdcall *SET_FLY_X)(double kx);
typedef void (__stdcall *N_SET_FLY_Y)(unsigned short n, double ky);
typedef void (__stdcall *SET_FLY_Y)(double ky);
typedef void (__stdcall *N_WRITE_IO_PORT_LIST)(unsigned short n, unsigned short value);
typedef void (__stdcall *WRITE_IO_PORT_LIST)(unsigned short value);
typedef void (__stdcall *N_SET_WAIT)(unsigned short n, unsigned short value);
typedef void (__stdcall *SET_WAIT)(unsigned short value);
typedef void (__stdcall *N_SIMULATE_EXT_START)(unsigned short n, short delay, short encoder);
typedef void (__stdcall *SIMULATE_EXT_START)(short delay, short encoder);
typedef void (__stdcall *N_WRITE_DA_X_LIST)(unsigned short n, unsigned short x, unsigned short value);
typedef void (__stdcall *WRITE_DA_X_LIST)(unsigned short x, unsigned short value);
typedef void (__stdcall *N_SET_PIXEL_LINE)(unsigned short n, unsigned short pixelmode, unsigned short pixelperiod, double dx, double dy);
typedef void (__stdcall *SET_PIXEL_LINE)(unsigned short pixelmode, unsigned short pixelperiod, double dx, double dy);
typedef void (__stdcall *N_SET_PIXEL)(unsigned short n, unsigned short pulswidth, unsigned short davalue, unsigned short adchannel);
typedef void (__stdcall *SET_PIXEL)(unsigned short pulswidth, unsigned short davalue, unsigned short adchannel);
typedef void (__stdcall *SET_LINE)(short dx, short dy, unsigned short n, unsigned short period, unsigned short *ptr);
typedef void (__stdcall *N_SET_EXTSTARTPOS_LIST)(unsigned short n, unsigned short position);
typedef void (__stdcall *SET_EXTSTARTPOS_LIST)(unsigned short position);
typedef void (__stdcall *N_LASER_SIGNAL_ON_LIST)(unsigned short n);
typedef void (__stdcall *LASER_SIGNAL_ON_LIST)(void);
typedef void (__stdcall *N_LASER_SIGNAL_OFF_LIST)(unsigned short n);
typedef void (__stdcall *LASER_SIGNAL_OFF_LIST)(void);
typedef unsigned short (__stdcall *N_GET_INPUT_POINTER)(unsigned short n);
typedef unsigned short (__stdcall *GET_INPUT_POINTER)(void);
typedef void (__stdcall *SELECT_RTC)(unsigned short cardno);
typedef unsigned short (__stdcall *RTC3_COUNT_CARDS)(void);
typedef void (__stdcall *N_GET_STATUS)(unsigned short n, unsigned short *busy, unsigned short *position);
typedef void (__stdcall *GET_STATUS)(unsigned short *busy, unsigned short *position);
typedef unsigned short (__stdcall *N_READ_STATUS)(unsigned short n);
typedef unsigned short (__stdcall *READ_STATUS)(void);
typedef unsigned short (__stdcall *N_GET_STARTSTOP_INFO)(unsigned short n);
typedef unsigned short (__stdcall *GET_STARTSTOP_INFO)(void);
typedef unsigned short (__stdcall *GET_DLL_VERSION)(void);
typedef void (__stdcall *N_SET_START_LIST_1)(unsigned short n);
typedef void (__stdcall *SET_START_LIST_1)(void);
typedef void (__stdcall *N_SET_START_LIST_2)(unsigned short n);
typedef void (__stdcall *SET_START_LIST_2)(void);
typedef void (__stdcall *N_SET_START_LIST)(unsigned short n, unsigned short listno);
typedef void (__stdcall *SET_START_LIST)(unsigned short listno);
typedef void (__stdcall *N_EXECUTE_LIST_1)(unsigned short n);
typedef void (__stdcall *EXECUTE_LIST_1)(void);
typedef void (__stdcall *N_EXECUTE_LIST_2)(unsigned short n);
typedef void (__stdcall *EXECUTE_LIST_2)(void);
typedef void (__stdcall *N_EXECUTE_LIST)(unsigned short n, unsigned short listno);
typedef void (__stdcall *EXECUTE_LIST)(unsigned short listno);
typedef void (__stdcall *N_WRITE_8BIT_PORT)(unsigned short n, unsigned short value);
typedef void (__stdcall *WRITE_8BIT_PORT)(unsigned short value);
typedef void (__stdcall *N_WRITE_IO_PORT)(unsigned short n, unsigned short value);
typedef void (__stdcall *WRITE_IO_PORT)(unsigned short value);
typedef void (__stdcall *N_AUTO_CHANGE)(unsigned short n);
typedef void (__stdcall *AUTO_CHANGE)(void);
typedef void (__stdcall *AUT_CHANGE)(void);
typedef void (__stdcall *N_START_LOOP)(unsigned short n);
typedef void (__stdcall *START_LOOP)(void);
typedef void (__stdcall *N_QUIT_LOOP)(unsigned short n);
typedef void (__stdcall *QUIT_LOOP)(void);
typedef void (__stdcall *N_STOP_EXECUTION)(unsigned short n);
typedef void (__stdcall *STOP_EXECUTION)(void);
typedef unsigned short (__stdcall *N_READ_IO_PORT)(unsigned short n);
typedef unsigned short (__stdcall *READ_IO_PORT)(void);
typedef void (__stdcall *N_WRITE_DA_1)(unsigned short n, unsigned short value);
typedef void (__stdcall *WRITE_DA_1)(unsigned short value);
typedef void (__stdcall *N_WRITE_DA_2)(unsigned short n, unsigned short value);
typedef void (__stdcall *WRITE_DA_2)(unsigned short value);
typedef void (__stdcall *N_SET_MAX_COUNTS)(unsigned short n, long counts);
typedef void (__stdcall *SET_MAX_COUNTS)(long counts);
typedef long (__stdcall *N_GET_COUNTS)(unsigned short n);
typedef long (__stdcall *GET_COUNTS)(void);
typedef void (__stdcall *N_SET_MATRIX)(unsigned short n, double m11, double m12, double m21, double m22);
typedef void (__stdcall *SET_MATRIX)(double m11, double m12, double m21, double m22);
typedef void (__stdcall *N_SET_OFFSET)(unsigned short n, short xoffset, short yoffset);
typedef void (__stdcall *SET_OFFSET)(short xoffset, short yoffset);
typedef void (__stdcall *N_GOTO_XYZ)(unsigned short n, short x, short y, short z);
typedef void (__stdcall *GOTO_XYZ)(short x, short y, short z);
typedef void (__stdcall *N_GOTO_XY)(unsigned short n, short x, short y);
typedef void (__stdcall *GOTO_XY)(short x, short y);
typedef unsigned short (__stdcall *N_GET_HEX_VERSION)(unsigned short n);
typedef unsigned short (__stdcall *GET_HEX_VERSION)(void);
typedef void (__stdcall *N_DISABLE_LASER)(unsigned short n);
typedef void (__stdcall *DISABLE_LASER)(void);
typedef void (__stdcall *N_ENABLE_LASER)(unsigned short n);
typedef void (__stdcall *ENABLE_LASER)(void);
typedef void (__stdcall *N_STOP_LIST)(unsigned short n);
typedef void (__stdcall *STOP_LIST)(void);
typedef void (__stdcall *N_RESTART_LIST)(unsigned short n);
typedef void (__stdcall *RESTART_LIST)(void);
typedef void (__stdcall *N_GET_XYZ_POS)(unsigned short n, short *x, short *y, short *z);
typedef void (__stdcall *GET_XYZ_POS)(short *x, short *y, short *z);
typedef void (__stdcall *N_GET_XY_POS)(unsigned short n, short *x, short *y);
typedef void (__stdcall *GET_XY_POS)(short *x, short *y);
typedef void (__stdcall *N_SELECT_LIST)(unsigned short n, unsigned short list_2);
typedef void (__stdcall *SELECT_LIST)(unsigned short list_2);
typedef void (__stdcall *N_Z_OUT)(unsigned short n, short z);
typedef void (__stdcall *Z_OUT)(short z);
typedef void (__stdcall *N_SET_FIRSTPULSE_KILLER)(unsigned short n, unsigned short fpk);
typedef void (__stdcall *SET_FIRSTPULSE_KILLER)(unsigned short fpk);
typedef void (__stdcall *N_SET_STANDBY)(unsigned short n, unsigned short half_period, unsigned short pulse);
typedef void (__stdcall *SET_STANDBY)(unsigned short half_period, unsigned short pulse);
typedef void (__stdcall *N_LASER_SIGNAL_ON)(unsigned short n);
typedef void (__stdcall *LASER_SIGNAL_ON)(void);
typedef void (__stdcall *N_LASER_SIGNAL_OFF)(unsigned short n);
typedef void (__stdcall *LASER_SIGNAL_OFF)(void);
typedef void (__stdcall *N_SET_DELAY_MODE)(unsigned short n, unsigned short varpoly, unsigned short direction, unsigned short edgelevel, unsigned short dummy1, unsigned short dummy2);
typedef void (__stdcall *SET_DELAY_MODE)(unsigned short varpoly, unsigned short direction, unsigned short edgelevel, unsigned short dummy1, unsigned short dummy2);
typedef void (__stdcall *N_SET_PISO_CONTROL)(unsigned short n, unsigned short l1, unsigned short l2);
typedef void (__stdcall *SET_PISO_CONTROL)(unsigned short l1, unsigned short l2);
typedef void (__stdcall *N_GET_ENCODER)(unsigned short n, short *zx, short *zy);
typedef void (__stdcall *GET_ENCODER)(short *zx, short *zy);
typedef void (__stdcall *N_SELECT_COR_TABLE)(unsigned short n, unsigned short heada, unsigned short headb);
typedef void (__stdcall *SELECT_COR_TABLE)(unsigned short heada, unsigned short headb);
typedef void (__stdcall *N_EXECUTE_AT_POINTER)(unsigned short n, unsigned short position);
typedef void (__stdcall *EXECUTE_AT_POINTER)(unsigned short position);
typedef unsigned short (__stdcall *N_GET_HEAD_STATUS)(unsigned short n, unsigned short head);
typedef unsigned short (__stdcall *GET_HEAD_STATUS)(unsigned short head);
typedef void (__stdcall *N_SIMULATE_ENCODER)(unsigned short n, unsigned short channel);
typedef void (__stdcall *SIMULATE_ENCODER)(unsigned short channel);
typedef void (__stdcall *N_SET_HI)(unsigned short n, double galvogainx, double galvogainy, short galvooffsetx, short galvooffsety, short head);
typedef void (__stdcall *SET_HI)(double galvogainx, double galvogainy, short galvooffsetx, short galvooffsety, short head);
typedef void (__stdcall *N_RELEASE_WAIT)(unsigned short n);
typedef void (__stdcall *RELEASE_WAIT)(void);
typedef unsigned short (__stdcall *N_GET_WAIT_STATUS)(unsigned short n);
typedef unsigned short (__stdcall *GET_WAIT_STATUS)(void);
typedef void (__stdcall *N_SET_CONTROL_MODE)(unsigned short n, unsigned short mode);
typedef void (__stdcall *SET_CONTROL_MODE)(unsigned short mode);
typedef void (__stdcall *N_SET_LASER_MODE)(unsigned short n, unsigned short mode);
typedef void (__stdcall *SET_LASER_MODE)(unsigned short mode);
typedef void (__stdcall *N_SET_EXT_START_DELAY)(unsigned short n, short delay, short encoder);
typedef void (__stdcall *SET_EXT_START_DELAY)(short delay, short encoder);
typedef void (__stdcall *N_HOME_POSITION)(unsigned short n, short xhome, short yhome);
typedef void (__stdcall *HOME_POSITION)(short xhome, short yhome);
typedef void (__stdcall *N_DSP_START)(unsigned short n);
typedef void (__stdcall *DSP_START)(void);
typedef void (__stdcall *N_WRITE_DA_X)(unsigned short n, unsigned short x, unsigned short value);
typedef void (__stdcall *WRITE_DA_X)(unsigned short x, unsigned short value);
typedef unsigned short (__stdcall *N_READ_AD_X)(unsigned short n, unsigned short x);
typedef unsigned short (__stdcall *READ_AD_X)(unsigned short x);
typedef unsigned short (__stdcall *N_READ_PIXEL_AD)(unsigned short n, unsigned short pos);
typedef unsigned short (__stdcall *READ_PIXEL_AD)(unsigned short pos);
typedef short (__stdcall *N_GET_Z_DISTANCE)(unsigned short n, short x, short y, short z);
typedef short (__stdcall *GET_Z_DISTANCE)(short x, short y, short z);
typedef void (__stdcall *WRITE_16BIT_PORT)(unsigned short value);
typedef void (__stdcall *SET_BASES)(unsigned short cardno, unsigned short base);
typedef void (__stdcall *SET_EXT2_MODE)(unsigned short mode);
typedef void (__stdcall *FIELD_JUMP)(short x, short y);
typedef void (__stdcall *HOME_JUMP)(short x, short y);
typedef void (__stdcall *SET_MODE)(unsigned short mode);
typedef void (__stdcall *SET_DELAYS)(unsigned short sp, unsigned short jd, unsigned short md, unsigned short pd, unsigned short loffd, unsigned short lond, unsigned short t1, unsigned short t2, unsigned short t3);
typedef unsigned short (__stdcall *GET_RTC2_MODE)(void);
typedef void (__stdcall *SET_BASE)(unsigned short value);
typedef void (__stdcall *SET_CO2_STANDBY)(unsigned short half_period, unsigned short pulse);
typedef void (__stdcall *SET_CO2_STANDBY_LIST)(unsigned short half_period, unsigned short pulse);
typedef short (__stdcall *LOAD_COR)(char* filename);
typedef short (__stdcall *LOAD_PRO)(char* filename);
typedef void (__stdcall *WRITE_DA)(unsigned short value);
typedef void (__stdcall *POLA_ABS)(short x, short y);
typedef void (__stdcall *POLB_ABS)(short x, short y);
typedef void (__stdcall *POLC_ABS)(short x, short y);
typedef void (__stdcall *WRITE_DA_LIST)(unsigned short value);
typedef void (__stdcall *LASER_ON)(unsigned short value);
typedef void (__stdcall *SET_SPEED)(double jumpspeed, double markspeed);
typedef void (__stdcall *SET_GAIN)(double xgain, double ygain, short xoffset, short yoffset);
typedef unsigned short (__stdcall *GET_VERSION)(void);
typedef void (__stdcall *SET_YAG_PARAMETER)(unsigned short parameter);
typedef void (__stdcall *SET_ENCODER_VALUES)(double kx, double ky, short zx, short zy);
typedef unsigned short (__stdcall *N_GET_SERIAL_NUMBER)(unsigned short n);
typedef unsigned short (__stdcall *GET_SERIAL_NUMBER)(void);
typedef unsigned short (__stdcall *N_GET_RTC_VERSION)(unsigned short n);
typedef unsigned short (__stdcall *GET_RTC_VERSION)(void);
typedef short (__stdcall *N_AUTO_CAL)(unsigned short n, unsigned short head, unsigned short command);
typedef short (__stdcall *AUTO_CAL)(unsigned short head, unsigned short command);
typedef void (__stdcall *N_SET_LIST_MODE)(unsigned short n, unsigned short mode);
typedef void (__stdcall *SET_LIST_MODE)(unsigned short mode);
typedef unsigned short (__stdcall *N_GET_LIST_SPACE)(unsigned short n);
typedef unsigned short (__stdcall *GET_LIST_SPACE)(void);
typedef unsigned short (__stdcall *GET_RTC2_VERSION)(void);
typedef void (__stdcall *WRITE_PORT_BYTE)(unsigned short wreg, unsigned char bdata);
typedef void (__stdcall *WRITE_PORT_WORD)(unsigned short wreg, unsigned short wdata);
typedef unsigned char (__stdcall *READ_PORT_BYTE)(unsigned short wreg);
typedef unsigned short (__stdcall *READ_PORT_WORD)(unsigned short wreg);

//// JT080128A Adding Custom Pulse Width Table for RTC4 ////
typedef void (__stdcall *N_SET_SOFTSTART_MODE)(unsigned short n, unsigned short mode, unsigned short number, unsigned short restartdelay);
typedef void (__stdcall *N_SET_SOFTSTART_LEVEL)(unsigned short n, unsigned short index, unsigned short level);
//// JT080128A /////////////////////////////////////////////

#endif // RTC3DLL_TYPE
