// Header file for CAbsStroke class
//
// American LaserWare, Inc
// Pat Summers
// 28 SEP 1999
//
// AbsStroke.h
//
///////////////////////////////////////////////////////////

//// 1.0307 PAT 23.03.00 TPO ADDITION TO VGRAPH ////
// Added this file
//// 1.0307 ////////////////////////////////////////

#ifndef ABSSTROKE
#define ABSSTROKE

// Include header files required for members
#include "AbsVector.h"

#define VER_ABSTROKE_19991007		100

const UINT ABSS_ADDLOC_FIRST		=	0;
const UINT ABSS_ADDLOC_HEAD			=	1;
const UINT ABSS_ADDLOC_TAIL			=	2;


class CAbsStroke : public CObject
{

//Attributes
public:
	UINT
		m_nVersion;

	long
		m_lX0, m_lY0,
		m_lX1, m_lY1;
	CObList
		m_VecList;

// Implementations
public:
	CAbsStroke(void);					// Constructor
	CAbsStroke(CAbsStroke&);			// Copy Constructor
	~CAbsStroke(void);					// Destructor
	void Init (void);					// Initialize members
	int ClearVecList(void);
	BOOL UpdateEnds(void);
	BOOL MeetsStartPoint(CAbsVector *pVec);
	BOOL MeetsEndPoint(CAbsVector *pVec);
	BOOL AddToHead(CAbsVector *pVec);
	BOOL AddToTail(CAbsVector *pVec);
	double GetHeadAngle(void);
	double GetTailAngle(void);
	BOOL IsClosedPolygon(void);
	void Reverse(void);
	CAbsVector *ShiftStartCW(void);
	CAbsVector *ShiftStartCCW(void);

// Operators
public:
};			

#endif


