// Header file for CAbsVector class
//
// American LaserWare, Inc
// Pat Summers
// 28 SEP 1999
//
// AbsVector.h
//
///////////////////////////////////////////////////////////

//// 1.0307 PAT 23.03.00 TPO ADDITION TO VGRAPH ////
// Added this file
//// 1.0307 ////////////////////////////////////////

#ifndef ABSVECTOR
#define ABSVECTOR

// Include header files required for members
#include "vgraph.h"
#include <math.h>

#define VER_ABSVECTOR_19991007		100

// Low * bits reserved for base types
// All higher bits 31-8 are flags for those types
const int ABSV_TYPE_MOVE			=	1;
const int ABSV_TYPE_LINE			=	2;
const int ABSV_TYPE_ARC				=	3;
const int ABSV_TYPE_STOP			=	255;

const int ABSV_TYPE_RELMOVE			=	1;
const int ABSV_TYPE_RELLINE			=	2;
const int ABSV_TYPE_RELARC			=	3;
const int ABSV_TYPE_RELSTOP			=	255;

const int ABSV_SIZE_RELMOVE			=	3;
const int ABSV_SIZE_RELLINE			=	3;
const int ABSV_SIZE_RELARC			=	5;
const int ABSV_SIZE_RELSTOP			=	1;

const int ABSV_TYPEMOD_MASK			=	0x000000ff;
const int ABSV_TYPEMOD_POLYSTART	=	0x00000100;
const int ABSV_TYPEMOD_POLYEND		=	0x00000200;

const double ABSV_ANGLE_BAD			=	2 * PI;
class CAbsVector : public CObject
{

//Attributes
public:
	UINT
		m_nVersion;

	UINT
		m_iType;
	long
		m_lX0, m_lY0,
		m_lX1, m_lY1,
		m_lDX, m_lDY,
		m_lI, m_lJ,
		m_lDI, m_lDJ;

// Implementations
public:
	CAbsVector(void);					// Constructor
	CAbsVector(CAbsVector&);			// Copy Constructor
	~CAbsVector(void);					// Destructor
	void Init (void);					// Initialize members
	BOOL IsNullVector();
	BOOL IsCircular();
	BOOL IsLinear();
	void ComputeDeltas(void);
	double GetLength(void);
	double GetAngle(void);
	double GetStartAngle(void);
	double GetEndAngle(void);
	void Reverse(void);

// Operators
public:
	void operator=(const CAbsVector&);	// Assignment operator
	BOOL operator==(const CAbsVector&);	// Equivalence operator

};			

#endif


