// BitVec.h
//
// Header file for the CBitVec class
///////////////////////////////////////////////

//// 1.0339 PAT 30.04.00 VECTORIZE BITMAPS ////
// Added this file
//// 1.0339 ///////////////////////////////////


#ifndef CBITVEC
#define CBITVEC

#include <afx.h>
#include <afxwin.h>

#define BIT_MASK_0			0x01
#define BIT_MASK_1			0x02
#define BIT_MASK_2			0x04
#define BIT_MASK_3			0x08
#define BIT_MASK_4			0x10
#define BIT_MASK_5			0x20
#define BIT_MASK_6			0x40
#define BIT_MASK_7			0x80

class CBitVec : public CObject
{

// Attributes
public:

	BYTE *
		m_pBytes;
	int
		m_iBitsPerPix;
	long
		m_lPixX,
		m_lPixY,
		m_lDotSizeX,
		m_lDotSizeY;
	int
		m_iVecScheme;
	long
		m_lRunStartPix;
	BOOL
		m_bBiDir,
		m_bVert;

	long *
		m_pVecList;
	long
		m_lVecListSize,
		m_lMaxListSize,
		m_lOffset;
	int
		m_aiBitArray[8];



// Operators
public:
	CBitVec(void);		// Constructor
	~CBitVec(void);		// Destructor
	void Init(void);	// Initiallize
	
	long *Vectorize(BYTE *pBytes, int iBitsPerPix, long lPixX, long lPixY,
		            long lDotSizeX, long lDotSizeY, int iVecScheme,
					long lRunStartPix, BOOL bBiDir, BOOL bVert);
	long GetMaxListSize(void);
	long *MakeDummyList(void);
	void AddFirstVector(long *pList);
	void AddLastVector(long *pList);
	void AddMove(long X, long Y, long *pList);
	void AddLine(long X, long Y, long *pList);
	void AddRunLine(long X, long Y, long *pList);
	void AddStop(long *pList);
	void ByteWise(BYTE);
	int Dots(long *pList);
	int Lines(long *pList);

};

#endif //CBitVec