// Header file for CBarCode class
//
// American LaserWare, Inc
// Pat Summers
// 25 FEB 1998
//
//	Serves to hold the infromation required to create
//	a bar code typeface for a given set of text.  This
//	includes various bar code fill parameters like beam
//	width and beam spacing as well as the bar-space trans-
//	lation of the text for the BCALI font.
///////////////////////////////////////////////////////////

// barcode.h

#ifndef CCHECKSUM
#define CCHECHSUM

// Include standard headers
#ifndef _DLL
	#include <afx.h>
	#include <afxwin.h>
#endif

// Checksum Errors
#define CHECKSUM_ERR_NOERROR					0
#define CHECKSUM_ERR_TYPEBAD					11
#define CHECKSUM_ERR_INSIZETOOSMALL				21
#define CHECKSUM_ERR_INSIZETOOBIG				22
#define CHECKSUM_ERR_INDATANULL					31
#define CHECKSUM_ERR_INDATATOOSMALL				32
#define CHECKSUM_ERR_INDATATOOBIG				33
#define CHECKSUM_ERR_CHARSETVIOLATION			41


// Checksum specific constant definitions
// Types and descriptions
#define CHECKSUM_TYPE_NONE			0
#define CHECKSUM_NAME_NONE			_T("NONE")

#define CHECKSUM_TYPE_SEMI_M13		1
#define CHECKSUM_NAME_SEMI_M13		_T("SEMI-M13")

// Limits
#define CHECKSUM_MIN_INSIZE			1
#define CHECKSUM_MAX_INSIZE			65000

#define CHECKSUM_MIN_TYPE			0
#define CHECKSUM_MAX_TYPE			CHECKSUM_TYPE_SEMI_M13


// Version
#define CHECKSUM_2006_12_05			0
	// Initial version!!!

#define VER_CHECKSUM		CHECKSUM_2006_12_05

class CChecksum
{

//Attributes
public:
	int m_nVersion;

	int m_iErr;

	int m_iType;

	CString m_sInData;
	CString m_sOutData;

// Implementations
public:
	CChecksum();						// Constructor
	~CChecksum();						// Destructor
	void Init(void);					// Initializes members
	
	int GetError(char *pError);
	
	int SetType(int iType);
	int SetInData(CString sInData);
	
	int GetChecksum(int iType, CString sInData, CString& sOutData);
	void GetTypeNone(void);
	void GetTypeSemiM13(void);

//Operators
public:
};

#endif

