// Header file for CCopyright class
//
// American LaserWare, Inc
// Pat Summers
// 1998.05.01
//
/****
	The CCopyright class is used to insert a copyright
	notice at the beginning of all American LaserWare,Inc.
	file types, including:
		*.alg	American LaserWare graphic files
		*.alf	American LaserWare font files
		*.laz	ProLase image files
		*.obj	ProLase object files (for linking)
		*.cfg	ProLase configuration files
		*.mat	ProLase material files
		*.fix	ProLase fixture files
	The archive function of this class writes or reads the
	copyright notice like
	** Copyright American LaserWare, Inc. XXXX All Rights
	Reserved **
	where XXXX is the current year as given by the clock.
	The notice is posted in the file as a string of bytes,
	not in a data structure like a CString.  The actual
	text (except the date) is defined as constant strings
	in this file.
****/
///////////////////////////////////////////////////////////

// copyrite.h

#ifndef CCOPYRIGHT
#define CCOPYRIGHT

// Include version info
#include "..\Versions\versions.h"

// Include headers for members
#include "filecons.h"

// Class specific definitions
		 	
class CCopyright : public CObject
{
	DECLARE_SERIAL (CCopyright)

	//Attributes
	public:
		// CCopyright class version info
		UINT
			m_nVersion;
		unsigned char
			m_iSize;
		char
			m_sComment[255];
		CString
			m_sCopy,
			m_sYear,
			m_sRights,
			m_sNotice;
		//// PS090611A UPDATE COPYRIGHT FOR ECONOLASE ////
		CString m_sName;
		//// PS090611A ///////////////////////////////////
	// Operations

	//Implementations
	public:
		CCopyright(void);		// Constructor
		~CCopyright(void);		// Destructor
		void Init(void);		// Initialize
		void Serialize(CArchive&);	
								// Load / Save routines
		void BuildNotice(void);	// Constructs the entire copyright
									// notice
};

#endif

