// Header file for CDisplay class
////////////////////////////////////
#ifndef DISPLAY
#define DISPLAY

#ifdef _ALIUSE
/*** DAN JAN 22 ***/
/*** 1.0084 12.22.98 MOVE CFG TO WSDATA PRJ ***/
	#include "WSData\Config.h"
/****1.0084************************************/
/******************/

/**********TESTING********/
	#include ".\GREngine\GREngine.h"

/*** 1.0063 PAT 30.05.98 PREFERENCES ***/
	#include ".\grid.h"
/***************************************/
#else
	#include "config.h"
	#include "grengine.h"
	#include "grid.h"
#endif


// Constant for accuracy (16/31 bit)
#define CD_ACC_OFFSET	32768
// double scale factor
#define CD_SCALE_MULT	2

// Vector Types
#define CD_MOVE		1
#define CD_LINE		2
#define CD_ARC		3
//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
#define CD_RUNLINE	4
//// 1.0699 /////////////////////////////////////

#define CD_MAX_VECTOR_BLOCK	100
//// PS090128A PREMOVE DELAY FOR DAC ////
//	#define CD_VECTOR_BLOCK_ADJUST	10
#define CD_VECTOR_BLOCK_ADJUST_MIN	10
#define CD_VECTOR_BLOCK_ADJUST_MAX	25
//// PS090128A //////////////////////////


// Scroll Bar ranges and values
#define SB_MIN		-64000
#define SB_MAX		64000
#define SB_PAGE		1000
#define SB_LINE		100

// Image Ranges and values
#define	CD_MIN_X	-64000
#define CD_MAX_X	64000
#define CD_MIN_Y	-64000
#define CD_MAX_Y	64000

// Base Unit
#define CD_BASE_INC	1000

// Ruler Mark ratios
#define	CD_BASE			0.80
#define CD_HALF			0.60
#define CD_TENTH		0.35
#define CD_TWENTIETH	0.20
#define CD_FORTIETH		0.10                                                                                        

/// 1.0506 DAN 3/17/03 DAN PROLASE DLL RULER DISPLAY ///
#define CD_ALL			0x0fff
#define CD_CLEAR		0x0001
#define CD_HRULER		0x0002
#define CD_VRULER		0x0004
#define CD_FORE			0x0008
#define CD_BACK			0x0010

#define CD_NO_RULERS	0x1000
////1.0506//////////////////////////////////////////////


// Handles Sizes
#define	CD_GHSIZE		3
#define CD_INFLATE		2
#define CD_SNAPSIZE		2

// Brushes
//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
//	#define	CD_NUM_BRUSHES	9
#define CD_NUM_BRUSHES	11
//// 1.0699 /////////////////////////////////////
#define	CD_RULER_BRUSH	0
#define CD_SCREEN_BRUSH	1
#define CD_GH_BRUSH		2
#define CD_GR_BRUSH		3
#define CD_GI_BRUSH		4
#define CD_POS_BRUSH	5
#define CD_ROTSNP_BRUSH	6
#define CD_ITLSNP_BRUSH	7
#define CD_RADIUS_BRUSH	8
//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
#define CD_SIZEROT_BRUSH	9
#define CD_DRILLCEN_BRUSH	10
//// 1.0699 /////////////////////////////////////


// Pens
//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
//	#define CD_NUM_PENS		16
#define CD_NUM_PENS		23
//// 1.0699 /////////////////////////////////////
#define CD_RULER_PEN	0
#define CD_ACTIVE_PEN	1
#define CD_BACK_PEN		2
#define CD_GH_PEN		3
#define CD_GR_PEN		4
#define CD_GI_PEN		5
#define CD_POS_PEN		6
#define CD_FIELD_PEN	7
#define CD_BBOX_PEN		8
#define CD_RULERMRK_PEN	9
#define CD_ROTSNP_PEN	10
#define CD_ITLSNP_PEN	11
#define CD_GRID_PEN		12
#define CD_SCND_ACT_PEN	13
#define CD_SCND_BAK_PEN	14
#define CD_RADIUS_PEN	15
//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
#define CD_MOVE_ACT_PEN		 16
#define CD_MOVE_SCND_ACT_PEN 17
#define CD_MOVE_BAK_PEN		 18
#define CD_MOVE_SCND_BAK_PEN 19
#define CD_SIZEROT_PEN	20
#define CD_DRILLCEN_PEN	21
#define CD_GROUP_PEN 22
//// 1.0699 /////////////////////////////////////

#define	CD_CENTER		-32000

struct SVectorInfo
{
	_TXCHAR cType;
	int	iX,
		iY,
		iI,
		iJ;
};

/*
struct SLongVectorInfo
{
	long	CurX,
			XXStep,
			XYStep,
			CurY,
			YYStep,
			YXStep,
			XLast,
			YLast,
			lNextVector;
};
*/
#define	CurX	0
#define XXStep	1
#define	XYStep	2
#define	CurY	3
#define	YYStep	4
#define	YXStep	5
#define XLast	6
#define	YLast	7
#define lNextVector	8

/*
struct SIntVectorInfo
{
	int		TDev,
			CmdType,
			XSteps,
			XDev,
			YSteps,
			YDev,
			VelX,
			VelY,
			VelXY,
			Timer5,
			iNextVector;
};
*/

#define	TDev	0
#define	CmdType	1
#define XSteps	2
#define XDev	3
#define YSteps	4
#define YDev	5
#define VelX	6
#define	VelY	7
#define	VelXY	8
#define	Timer5	9
#define iNextVector	10

#ifndef _PROLASEDLL
	#define DllExport
#else
	#define DllExport   __declspec( dllexport )
#endif // _PROALSEDLL


class DllExport CDisplay
{
// Attributes
protected:
	int GetCenterY();
	int GetCenterX();

/**** TESTING *********/
public:
/**********************/

	CObject	*m_pView;

	CItem	*m_pCurrItem;

	COLORADJUSTMENT	m_ColorAdjustment;


//	CGREngine	m_DaVinci;
	CGREngine	*m_pDaVinci;

	/*** Dan JAN 22 ***/
	CConfig *m_pConfig;
	/******************/


	// Device contexts for display
	CDC	m_HRDC,
		m_VRDC,
		m_BackDC,
		m_ForeDC;

	// Pointer to the current DC
	CDC *m_pCurrDC;

	// Bitmaps for display
	CBitmap	*m_pHRBitmap,
			*m_pVRBitmap,
			*m_pBackBitmap,
			*m_pForeBitmap;
	// Temp storage bitmap pointers
	CBitmap	*m_pHRTempBitmap,
			*m_pVRTempBitmap,
			*m_pBackTempBitmap,
			*m_pForeTempBitmap;


	// System size information
	int	m_iRulerWidth,
		m_iWidth,
		m_iHeight;

	/*** 1.0013 DAN 4/25/98 LAYER SELECTION BUTTONS ***/
	int m_iLButtonHeight;
	int m_iLButtonWidth;
	/**************************************************/


	CRect	m_HRRect,
			m_VRRect,
			m_ScreenRect;

	CSize	m_WinSize;

	// Positioning / Zoom Information
	int	m_iXPos,
		m_iYPos;

	int m_iZoom;

	// Offset for BBox pixels
	long m_lBBoxOffset;


	// Handles sizes
	int	m_iGHSize;
	// Snap Setting size
	int m_iSnpSize;

	// Brushes
	CBrush*	m_pBrushes[CD_NUM_BRUSHES];

	// Temp Brush pointers
	CBrush	*m_pHRTempBrush,
			*m_pVRTempBrush,
			*m_pBackTempBrush,
			*m_pForeTempBrush;

	COLORREF	m_RulerDCColor;

	// Pens
	CPen* m_pPens[CD_NUM_PENS];

	// Temp Pen pointers
	CPen	*m_pHRTempPen,
			*m_pVRTempPen,
			*m_pBackTempPen,
			*m_pForeTempPen;

	// Colors
	COLORREF	m_BrushColor[CD_NUM_BRUSHES],
				m_PenColor[CD_NUM_PENS];


	/*** 1.0063 PAT 30.05.98 PREFERENCES ***/
	// Don't eliminate the old grid values just yet.
	// Keep them for testing.
	// Add XferGrid(BOOL) functions to move the data between the
	// old members and the CGrid class
	CGrid
		m_Grid;
	/***************************************/


	// Snap Setting Values
//	UINT	m_bSnapToGrid,
//			m_bShowGrid,
//			m_bSnapToRot,
//			m_bShowRot,
//			m_bSnapToItl,
//			m_bShowItl;
//	int		m_iGridInc,
//			m_iGridType,
//			m_iRotInc,
//			m_iItlInc;

	// Ruler Lines last point
	CPoint	m_LastRulerPoint;
	// ROP2 drawing style
	int	m_iRop2;


	// Simulate Mode flag
	UINT	m_bSimulate;


// Operators
public:

	CPoint CenterAt (int iX, int iY);
	/// 1.0256 DAN 11/19/99 PROLASE PLUS LAYER FIX ///
	CPoint CenterAt (CLayer *pLayer);
	////1.0256////////////////////////////////////////
	CPoint CenterAtScreen (int iX, int iY);
	CPoint ZoomOut (int iX = CD_CENTER, int iY = CD_CENTER);
	CPoint ZoomIn (int iX = CD_CENTER, int iY = CD_CENTER);
	/// 1.0256 DAN 11/19/99 PROLASE PLUS LAYER FIX ///
	CPoint ZoomField(CLayer *pLayer);
	////1.0256////////////////////////////////////////

	// Construction / Destruction
	CDisplay();
	~CDisplay();
	void GrabTempObjects(void);
	void ReturnTempObjects(void);

	// Initialization Routines
	void CreateCompatibleDisplay (CDC *pDC, int iRulerWidth);
	void CreateBitmaps(CDC *pDC, int iRulerWidth);
	void CreateBrushes(CDC *pDC);
	void CreatePens(void);
	void InitializeBitmaps(void);
	void ClearBitmaps(UINT nFlags = CD_ALL);

	// Update Routines
	void UpdateScreen(CDC *pDC, UINT nFlags = CD_ALL, CWSData *pData = NULL, UINT bFastDraw = FALSE);
	void UpdateRulers(CDC *pDC);
	void OnScroll(UINT nType, int iPosition);
	/// 1.0506 DAN 3/17/03 DAN PROLASE DLL RULER DISPLAY ///
	void OnSize(int iX, int iY, BOOL bRulers = TRUE);
	////1.0506//////////////////////////////////////////////
	void SetPos(int iXPos, int iYPos, int iZoomFactor = 0);
	void SetZoom (int iZoomFactor);	
		
	// Drawing Routines
	void DrawRulerLines (CDC *pDC, CPoint point, UINT bDrawLines = TRUE);
	void DrawRulers(UINT nRuler = CD_ALL);
	void DrawRulerMark (int iStartPos, int iStopPos, int iMarkInc, long double ldMarkLength, UINT nRuler);
	/*** 1.0020 DAN 98.05.10 VARIABLE RULER INCREMENT ***/
	void DrawRulerInc (int iStartPos, int iStopPos, int iMarkInc, long double ldMarkLength, UINT nRuler, BOOL bEveryOtherInc, BOOL bEveryThirdInc);
	/****************************************************/
	
	/// 1.0256 DAN 11/19/99 PROLASE PLUS LAYER FIX ///
	void DrawFieldBox(CLayer *pLayer, UINT nDC = CD_BACK, CDC *pDC = NULL, int iOffset = 0);
	void DrawFieldBox(long lXOffset, long lYOffset, UINT nDC, CDC *pDC, int iOffset);

	////1.0256////////////////////////////////////////
	void DrawOldBox(long lXOffset, long lYOffset, UINT nDC, CDC *pDC, int iOffset);
	void DrawCurrentBox(long lXOffset, long lYOffset, UINT nDC, CDC *pDC, int iOffset);

	// Conversion Routines
	int BtoSx (int iX);
	int BtoSy (int iY);
	int StoBx (int iX);
	int StoBy (int iY);

	/// 1.0240 DAN 8/30/99 PRINTING - FIXING THE PRINT PROBLMES ///
	int StoPx (int iX);
	int StoPy (int iY);

	long double m_ldPrinterToScreenRatio;

	BOOL m_bPrinting;

	void PrintScreen(CDC *pDC, CWSData *pData);
	////1.0240/////////////////////////////////////////////////////


	void SetColors (void);


	// Drawing Routines
	void DrawVectors (long *lVecInfo, int *iVecInfo);

	void DrawSymbol (long *Vectors, long lXAbs, long lYAbs, long double ldRot, long double ldItl, long double ldScale, long double ldXComp);
	void DrawSymbolFast (long *Vectors, long lXAbs, long lYAbs, long double ldRot, long double ldItl, long double ldScale, long double ldXComp, CPen *pPen);
	void AddVector  (int LVec, int IVec, long lType,
					 long lX, long lY, long lI, long lJ,
					 long double ldXCur, long double ldYCur,
					 long double DeltaX, long double iDeltaY);
	//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
	//	void DrawLineSymbol (CItem *pItem);
	void DrawLineSymbol(CItem *pItem, BOOL bFore, BOOL bBase);
	//// 1.0699 /////////////////////////////////////
	
	// Item Drawing routines
	void DrawItems (CWSData *pData);
	/// 1.0240 DAN 8/30/99 PRINTING - FIXING THE PRINT PROBLMES ///
	void DrawBackgroundItems(CWSData *pData, CDC *pDC = NULL);
	////1.0240/////////////////////////////////////////////////////
	
	/// 1.0256 DAN 11/19/99 PROLASE PLUS LAYER FIX ///
	void DrawGrid (CLayer *pLayer, CDC *pDC, int iOffset = 0);
	////1.0256////////////////////////////////////////

	/// 1.0250 DAN 10/3/99 TEMPORARY GROUP SELECTION ///
	void DrawForegroundItems(CWSData *pData, CDC *pDC = NULL);
	void DrawForegroundItems(CItem *pItem, CWSData *pData, BOOL bGroupMaster = FALSE, BOOL bBoundingBox = TRUE, CDC *pDC = NULL);
	////1.0250//////////////////////////////////////////

	// Unsorted
	void SetPen (int nPen, UINT nDC = CD_FORE);
	void ArcTo (int iX, int iY, int iXCenter, int iYCenter, UINT bBackground = FALSE);
	void MoveTo (int iX, int iY, UINT bBackground = FALSE);
	void LineTo (int iX, int iY, UINT bBackground = FALSE);

	/// 1.0362 DAN 3/24/01 GROUP SELECTION AND MANIPULATION ///
	void DrawGroupBoundingBox (CBBox *pBBox);
	////1.0362/////////////////////////////////////////////////
	void DrawBoundingBox (CBBox *pBBox);
	void DrawRotSnaps (CDC *pDC, CBBox *pBBox);
	void DrawItlSnaps (CDC *pDC, CBBox *pBBox);

	UINT	m_bWinLineTo;

// Drawing routine variables
// Are here so that they are not
// reallocated each time function is called
	// Drawing color
	COLORREF	m_DrawingColor;
	// Errors
	int	m_iTerr,
		m_iXerr,
		m_iYerr;
//		m_iXYerr;

	int	m_iXDeltaErr,
		m_iYDeltaErr;

	// temp Errors (used to determine course of action)
	int m_iXTempErr,
		m_iYTempErr,
		m_iXYTempErr;

	// Counters
	int	m_iXCnt,
		m_iYCnt;

	// Position variables
	long m_lTrueX,
		 m_lTrueY,
		 m_lXStep,
		 m_lYStep;

	int	m_iCurrX,
		m_iCurrY;

	// Step Size variable
	long double	m_ldStepResX,
				m_ldStepResY;

	long double m_ldXXStep,
				m_ldXYStep,
				m_ldYXStep,
				m_ldYYStep;

	long	m_lXXStep,
			m_lXYStep,
			m_lYXStep,
			m_lYYStep;

	long double m_ldXStep,
				m_ldYStep;

	long double m_ldRotCos,
				m_ldRotSin,
				m_ldItlCos,
				m_ldItlSin;

	// Scaling Info
	long double m_ldScale;

	// Vector information to be sent to 
	// drawing engine
	long	m_lVecInfo[(CD_MAX_VECTOR_BLOCK+1) * lNextVector];
	int		m_iVecInfo[(CD_MAX_VECTOR_BLOCK+1) * iNextVector];

	/*** 1.0036 DAN 9.6.98 GRAPHIC MEMORY REVISE ***/
	BOOL	m_bCopyTest;
	BOOL	m_bUseTest;

	long double
		m_ldFillScale,
		m_ldFillXComp;
	void SetFillScale(ClGHeader *);
	long double FillScale(long double);
	long double FillXComp(long double);
	/***********************************************/

	/*** 1.0129 PAT 21.12.98 NEW BITMAPS ***/
	void DrawRasterImage(CItem *);
	/*** 1.0129 ****************************/

	// DLL Functionality
	void CreateCompatibleDisplay(CDC *pDC, int iRulerWidth, CObject *pMarkObj);

	//// 1.0345 PAT 03.05.00 DRAW GRAPHIC HANDLE FUNCTIONS ////
	void DrawHandlePos(CDC *pDC, CBBox *pBBox);
	void DrawHandleCorners(CDC *pDC, CBBox *pBBox);
	void DrawHandleRot(CDC *pDC, CBBox *pBBox);
	void DrawHandleItl(CDC *pDC, CBBox *pBBox);
	void DrawHandleCenter(CDC *pDC, CBBox *pBBox);
	void DrawHandleCenterRot(CDC *pDC, CBBox *pBBox);
	//// 1.0345 ///////////////////////////////////////////////

	/// 1.0350 DAN 1/4/01 DLL OBJECT ALLOCATION - DEALLOCATION ROUTINES //
public:
	static CDisplay *NewDisplay(void);
	static void DeleteDisplay(CDisplay *pDisplay);
	////1.0350////////////////////////////////////////////////////////////

	//// 1.0529 PAT 19.04.01 LASSO ////
	void DrawGroupBox(CDC *pDC, CPoint Pos1, CPoint Pos2);
	CPoint
		m_GBPos1,
		m_GBPos2;
	//// 1.0529 ///////////////////////

	//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
	void DrawDrillSymbol(CItem *pItem, BOOL bFore, BOOL bBase);
	void DrawHandleSizeRot(CDC *pDC, CBBox *pBBox, BOOL bLine = TRUE);
	void DrawHandleDrillCenter(CDC *pDC, CBBox *pBBox);
	//// 1.0699 /////////////////////////////////////

	void ChoosePen(int iLayerMode, int iItemMode, BOOL bMain, CPen**pPen, COLORREF*crColor);

	
	//// 1.1257 PAT 09.11.06 BACKGROUND LINE COLOR ////
	void DrawLineSymbol2(CItem *pItem, CPen *pPen);
	void DrawDrillSymbol2(CItem *pItem, CPen *pPen);
	//// 1.1257 ///////////////////////////////////////

	//// PS080414A GALVO TRACKING ////
	CPoint m_PosTrackStart;
	CPoint m_PosTrackEnd;
	void DrawTrackLine(CDC *pDC, CPoint Pos1, CPoint Pos2);
	//// PS080414A ///////////////////

};
#endif