// DotMatrixFont.h
//
// Header file for the CDotMatrixFont class
//////////////////////////////////////////////

//// 1.0683 PAT 27.06.02 DOT MATRIX FONT ////
// Added this file
//// 1.0683 /////////////////////////////////


#ifndef DOTMATRIXFONT
#define DOTMATRIXFONT

#include <afx.h>
#include <afxwin.h>

// Include version info
#ifdef _ALIUSE
	#include "..\Versions\versions.h"
#else
	#include "versions.h"
#endif

//// 1.1325 PAT 08.06.07 UNTYPED FIXES ////
//	const DOTMATRIXFONT_0					= 20020724;	
const int	DOTMATRIXFONT_0					= 20020724;	
//// 1.1325 ///////////////////////////////

const int	VER_DOTMATRIXFONT				=	DOTMATRIXFONT_0;


const int	DMF_CHAR_MAX					=	255;
const int	DMF_DIM_MAX						=	10;
const int	DMF_DIM_ROWS					=	DMF_DIM_MAX;
const int	DMF_DIM_COLS					=	DMF_DIM_MAX;

const int	DMF_SPACING_MIN					=	0;
const int	DMF_SPACING_MAX					=	10;

const int	DMF_TYPE_5_BY_7					=	0;
#define		DMF_TYPE_5_BY_7_NAME			_T("5 x 7")

const int	DMF_RENDERMODE_RASTER			=	0;

// Class specific definitions

class CDotMatrixFont : public CObject
{

// Attributes
public:

	UINT
		m_nVersion;		// Archive version
	// User parameters
	int
		m_iType;
	int
		m_iGap,
		m_iRowsBetweenLines,
		m_iColsBetweenChars;
	int
		m_iRenderMode;

	// Font data variables
	CString
		m_sName;
	int
		m_iRows,
		m_iCols,
		m_iSpacingDots,
		m_iSpacingRows,
		m_iSpacingCols;
	BOOL
		m_bCharFlag[DMF_CHAR_MAX];
	BOOL
		m_bCharData[DMF_CHAR_MAX][DMF_DIM_ROWS][DMF_DIM_COLS];

	// Usage variables
	CString
		m_sRoot;
	BOOL
		m_bLoaded;
	int 
		m_iTextRows,
		m_iTextCols;
	BOOL
		*m_pTextData;

	int
		m_iTextRowsRaster,
		m_iTextColsRaster;
	BOOL
		*m_pTextDataRaster;
	HANDLE
		m_hImage;

// Operators

public:
	// Contructor / Destructor
	CDotMatrixFont(void);
	~CDotMatrixFont(void);
	void Init(void);	// Initiallize
	void operator =( const CDotMatrixFont& );
	BOOL operator ==( const CDotMatrixFont& );
	//// 1.0687 PAT 22.07.02 DOT MATRIX ADDITIONS ////
	void Serialize( CArchive &ar);
	//// 1.0687 //////////////////////////////////////

	BOOL Load(void);
	BOOL SetType(int iType);
	CString GetName(void);
	
	BOOL RenderText(CString sText);
	BOOL RenderImage(void);
	BOOL RenderAsRaster(void);
	BOOL IsRenderAsRaster(void);

	double GetEquivalentHeight(void);
	double GetEquivalentLengthRatio(void);
};

#endif // DOTMATRIXFONT