// Header file with constants for Drivers class
//
// drivers.h
//

//// 1.0263 PAT 22.12.99 RTC2 DRIVER DLG ////
#ifndef DRIVERS
#define DRIVERS
//// 1.0263 /////////////////////////////////

// Define Driver Types
#define CI_DDA0612			0
#define	CI_SCANLAB			1
#define CI_DDA0616			4
#define CI_DADIO			6
#define CI_603X				2
#define CI_32BITXY			3
//// 1.0253 PAT 23.11.99 SYNRAD FLCC DRIVER ////
// Replace HPGL with Synrad
//#define CI_HPGL				5
#define CI_SYNRAD			5
//// 1.0253 ////////////////////////////////////
#define CI_UMCLM45			7
/// 1.0270 DAN 12/20/99 SCANLAB RTC2 DRIVER ///
#define CI_RTC2				8
////1.0270/////////////////////////////////////
/// 1.0320 DAN 8/1/00 PLOTTER MARKER DRIVER ADDITIONS ///
#define CI_PLOTTER_ULS		9
////1.0320///////////////////////////////////////////////
//// 1.0417 PAT 16.08.00 LM50 ADDITIONS ////
#define CI_UMCLM50			10
//// 1.0417 ////////////////////////////////
//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
#define CI_RTC3				11
//// 1.0445 /////////////////////////////
//// 1.0835 PAT 02.03.04 RTC4 ////
#define CI_RTC4				12
//// 1.0835 //////////////////////
//// 1.1037 PAT 25.07.05 SCANALONE ////
#define CI_RTCSA4				13
//// 1.1037 ///////////////////////////

/************************************************/
// PCI Product IDs for Computer Boards Inc.      /
//                                               /
#define PCI_CTR05		24
#define PCI_DDA02_12	32
#define PCI_DDA04_12	33
#define PCI_DDA08_12	34
#define PCI_DDA02_16	35
#define PCI_DDA04_16	36
#define PCI_DDA08_16	37
#define PCIM_DDA06_16	83
//////////////////////////////////////////////////

//// 1.0263 PAT 22.12.99 RTC2 DRIVER DLG ////
// Driver init error codes
// NO ERRORS
const UINT DRV_ERR_NONE					=	0;
// DDA06-12
const UINT DRV_ERR_DDA0612				=	10;
// ScanLab PC1000
const UINT DRV_ERR_SCANLAB				=	100;
// Cambridge 603x
const UINT DRV_ERR_603X					=	200;
// 32 bit XY
const UINT DRV_ERR_32BITXY				=	300;
// DDA06-16
const UINT DRV_ERR_DDA0616				=	400;
// Synrad FLCC
const UINT DRV_ERR_SYNRAD				=	500;
// DADIO
const UINT DRV_ERR_DADIO				=	600;
// Unitek Miyachi LM-45
const UINT DRV_ERR_UMCLM45				=	700;
// ScanLab RTC2
const UINT DRV_ERR_RTC2					=	800;
const UINT DRV_ERR_RTC2_DLL				=	801;
const UINT DRV_ERR_RTC2_BOARD			=	802;
const UINT DRV_ERR_RTC2_PROGFILE		=	803;
const UINT DRV_ERR_RTC2_CTBFILE			=	804;
//// 1.0263 /////////////////////////////////
//// 1.0417 PAT 16.08.00 LM50 ADDITIONS ////
const UINT DRV_ERR_UMCLM50				=	900;
//// 1.0417 ////////////////////////////////

//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
const UINT DRV_ERR_RTC3					=	1000;
const UINT DRV_ERR_RTC3_DLL				=	1001;
const UINT DRV_ERR_RTC3_BOARD			=	1002;
const UINT DRV_ERR_RTC3_PROGFILE		=	1003;
const UINT DRV_ERR_RTC3_CTBFILE			=	1004;
//// 1.0445 /////////////////////////////

//// 1.0835 PAT 02.03.04 RTC4 ////
const UINT DRV_ERR_RTC4					=	1100;
const UINT DRV_ERR_RTC4_DLL				=	1101;
const UINT DRV_ERR_RTC4_BOARD			=	1102;
const UINT DRV_ERR_RTC4_PROGFILE		=	1103;
const UINT DRV_ERR_RTC4_CTBFILE			=	1104;
//// 1.0835 //////////////////////

//// 1.1037 PAT 25.07.05 SCANALONE ////
const UINT DRV_ERR_RTCSA4				=	1200;
const UINT DRV_ERR_RTCSA4_DLL			=	1201;
const UINT DRV_ERR_RTCSA4_BOARD			=	1202;
const UINT DRV_ERR_RTCSA4_PROGFILE		=	1203;
const UINT DRV_ERR_RTCSA4_CTBFILE		=	1204;
const UINT DRV_ERR_RTCSA4_USB			=	1205;
//// 1.1037 ///////////////////////////

//// 1.0405 PAT 26.07.00 RTC2 GRAYSCALE ////
// Constant for accuracy (16/32 bit)
#define CM_ACC_OFFSET	65536
#define CM_ACC_SHIFT	16
// double scale factor
#define CM_SCALE_MULT	1

// Vector Types
#define CD_MOVE		1
#define CD_LINE		2
#define CD_ARC		3
#define CD_VELMOVE	4
//// 1.1285 PAT 24.01.07 GRAPHIC EMBEDDED SPOTS ////
#define CD_SPOT		5
//// 1.1285 ////////////////////////////////////////
//// PS090128A PREMOVE DELAY FOR DAC ////
#define CD_DELAY	6
#define CD_DELAYMAX	7
//// PS090128A //////////////////////////

// Vector Types for Engine
#define CE_MOVE		-3
#define CE_LINE		0
#define CE_ARC1		2
#define CE_ARC2		-2
#define CE_QUIT		-1

#define CD_MAX_VECTOR_BLOCK	100
//// PS090128A PREMOVE DELAY FOR DAC ////
//	#define CM_VECTOR_BLOCK_ADJUST	10
#define CD_VECTOR_BLOCK_ADJUST_MIN	10
#define CD_VECTOR_BLOCK_ADJUST_MAX	25

#define TIMER5_MAX_MICROSECONDS	27460
//// PS090128A //////////////////////////

#define CLOCK_PER_SEC	1193180

// Drawing Engine Constants
const int temp = 300;

#define	CurX	0
#define XXStep	1
#define	XYStep	2
#define	CurY	3
#define	YYStep	4
#define	YXStep	5
#define XLast	6
#define	YLast	7

#define lNextVector	8

#define	TDev	0
#define	CmdType	1
#define XSteps	2
#define XDev	3
#define YSteps	4
#define YDev	5
#define VelX	6
#define	VelY	7
#define	VelXY	8
#define	Timer5	9

#define iNextVector	10


const int	RAS_NBYTE = 10;
const int	RAS_NBIT = 11;
const int	RAS_BABYSTEPSIZE = 12;
const int	iNextVectorRaster = 13;

const short RAS_CMD_END = -1;
const short RAS_CMD_MOVE = 0;
const short RAS_CMD_INC	= 1;
const short RAS_CMD_DOT = 2;
const short RAS_CMD_LINE = 3;
const short RAS_CMD_BACKUP	=	4; 
const short RAS_CMD_SPEEDUP =	5;


//// 1.0405 ////////////////////////////////



//// 1.0263 PAT 22.12.99 RTC2 DRIVER DLG ////
#endif // DRIVERS
//// 1.0263 /////////////////////////////////
