// Header file for the CGrid class
//
// grid.h

// This class will store the data for the grid settings, including both
// size and whether to display it for the general grid, rotate and italic.

#ifndef CGRID
#define CGRID

#ifdef _ALIUSE
// Include version info
	#include ".\Versions\versions.h"
#else
	#include "versions.h"
#endif

#define GRID_TYPE_DOTS		1
#define GRID_TYPE_LINES		2
#define GRID_INC			200
#define GRID_ROTINC			300
#define GRID_ITLINC			300

class CGrid : public CObject
{

	DECLARE_SERIAL(CGrid)
		
// Attributes
public:
	// Version info
	UINT
		m_nVersion;
	BOOL
		m_bShowGrid,
		m_bSnapToGrid,
		m_bShowRot,
		m_bSnapToRot,
		m_bShowItl,
		m_bSnapToItl;
	int
		m_iGridType,
		m_iGridInc,
		m_iRotInc,
		m_iItlInc;

	//// 1.1267 PAT 14.11.06 GRID OFFSET ////
	int m_iOffsetX;
	int m_iOffsetY;
	//// 1.1267 /////////////////////////////
	
// Implementations
public:
	CGrid(void);
	~CGrid(void);

	void	Init(void);

	void	Serialize(CArchive&);
// Operators
	void operator =( const CGrid&);
	BOOL operator ==(const CGrid&);
public:
};

#endif
