// Material.h
//
// Header file for the CMaterial Class
//////////////////////////////////////////////
/*** 1.0070 2.9.98 FIXTURE MATERIAL MODELESS ***/
/****1.0070*************************************/

#ifndef CMATERIAL
#define CMATERIAL

/// 1.0340 DAN 11/25/00 PLOTTER MARKER DRIVER ADDITIONS 2 ///
#ifdef _ALIUSE
	#include "..\Versions\Versions.h"
#else
	#include "Versions.h"
#endif
////1.0340///////////////////////////////////////////////////
#include <afx.h>

#define CM_DEFAULT_FILE	_T("DEFAULT.MAT")

#define CM_MAX_PASSES	7

class CMaterial
{
// Attributes
public:
	/// 1.0340 DAN 11/25/00 PLOTTER MARKER DRIVER ADDITIONS 2 ///
	UINT	m_nVersion;
	////1.0340///////////////////////////////////////////////////

	// Path Name to the material file
	CString		m_sPathName;

	// Material Name
	CString		m_sMatName;

	// Power values
	double	m_adPower[CM_MAX_PASSES];

	// Speed values
	double	m_adSpeed[CM_MAX_PASSES];

	// Frequency values
	double	m_adFreq[CM_MAX_PASSES];


	/// 1.0340 DAN 11/25/00 PLOTTER MARKER DRIVER ADDITIONS 2 ///
	UINT	m_nColor[CM_MAX_PASSES];

	UINT	m_nWidth[CM_MAX_PASSES];
	////1.0340///////////////////////////////////////////////////
	int		m_aiQWidth[CM_MAX_PASSES];
	BOOL	m_abQDefault[CM_MAX_PASSES];

	// Flag for state in tree
	BOOL	m_bOpenInTree;
	
	/*** 1.0070 2.9.98 FIXTURE MATERIAL MODELESS ***/
	BOOL	m_bModified;
	/****1.0070*************************************/



// Operators
public:
	CMaterial(void);
	~CMaterial(void);

	void Init(void);

	//// 1.0363 PAT 19.05.00 MATERIAL AND FIXTURE INIT ////
	void InitLoad(void);
	//// 1.0363 ///////////////////////////////////////////

	BOOL Load(CString sPathName);
	BOOL Save(CString sPathName = _T(""));

	/*** 1.0070 2.9.98 FIXTURE MATERIAL MODELESS ***/
	void SetModified(void);

	// equate operator =
	void operator =( const CMaterial& src );
	// equivalence operator ==
	BOOL operator ==( const CMaterial& src );
	/****1.0070*************************************/

	//// 1.1409 PAT 02.01.08 MAT/FIX MISSING MSG ////
	BOOL CreateDefaultFile(CString sPathName);
	//// 1.1409 /////////////////////////////////////
	

};
#endif
