
// WSTimer.h

#ifndef WSTIMER
#define WSTIMER

//// PS090423A WSTIMER MODE ////
#define WSTIMER_MODE_CONCURRENT		0
#define WSTIMER_MODE_DELAYONLY		1
//// PS090423A /////////////////

class CWSTimer : public CObject
{
protected:
	BOOL m_bReady;
	BOOL m_bTiming;

	__int64 m_i64QPCFreq;
	__int64 m_i64QPCStart, m_i64QPCStop;

	long double m_ldOverhead;

	//// PS090423A WSTIMER MODE ////
	int m_iMode;

	BOOL StartTimingXXX(void);
	BOOL StopTimingXXX(void);
	BOOL GetTimingCountsXXX(__int64 *pCounts);
	BOOL GetTimingSecondsXXX(double *pSeconds);
	BOOL GetElapsedCountsXXX(__int64 *pCounts);
	BOOL GetElapsedSecondsXXX(double *pSeconds);
	//// PS090423A /////////////////

public:
	CWSTimer();
	~CWSTimer();

	__int64 GetFreq(void);

	BOOL Init(void);
	BOOL IsReady(void);
	BOOL IsTiming(void);


	BOOL StartTiming(void);
	BOOL StopTiming(void);
	BOOL GetTimingCounts(__int64 *pCounts);
	BOOL GetTimingSeconds(double *pSeconds);
	BOOL GetElapsedCounts(__int64 *pCounts);
	BOOL GetElapsedSeconds(double *pSeconds);

	BOOL DelayCounts(__int64 nCounts, unsigned long *pLoops);
	BOOL DelaySeconds(double dSeconds, unsigned long *pLoops);

	//// PS090423A WSTIMER MODE ////
	int GetMode();
	
	CWSTimer(int iMode);
	//// PS090423A /////////////////
};


#endif	// WSTIMER